//=============================================================================
// ChainDispatcher.
//=============================================================================
class ChainDispatcher extends Dispatcher;
// Remembers who Triggered it
// and passes this information along the chain of command

var actor SavedTrigger ;

//
// When dispatcher is triggered...
//
function Trigger( actor Other, pawn EventInstigator )
{
    SavedTrigger  = Other ;
    super.Trigger( Other, EventInstigator );
}

//
// Dispatch events.
//
state Dispatch
{
Begin:
    disable('Trigger');
    for( i=0; i<ArrayCount(OutEvents); i++ )
    {
        if( OutEvents[i] != '' )
        {
            Sleep( OutDelays[i] );
            foreach AllActors( class 'Actor', Target, OutEvents[i] )
                Target.Trigger( SavedTrigger, Instigator );
        }
    }
    enable('Trigger');
}

defaultproperties
{
}
