//=============================================================================
// MultiSkyCloudZone.
//
// by Steve Nabors
//
// www.planetunreal.com/slick
// slickWilly@planetunreal.com
//
// To use just create your skyboxes and give them each their own
// SkyZoneInfo.  When you place your SkyZoneInfo,  give it a tag name.
//
// Now place this zoneinfo in place of the normal CloudZone actor in
// the parts of the map where you have Fake BackDrops.
//
// Once you place this ZoneInfo in your level you will give it the
// the name of the skybox tag in it's event tag.  In the 2d view you
// will then see a link line to your skyzoneinfo.  Once linked up
// all fakebackdrop textures in the zone with this actor will point
// to the proper skybox info.  
//
//=============================================================================
class MultiSkyCloudZone expands ZoneInfo;

event ActorEntered( actor Other )
{
	if ( Other.IsA('Pawn') )
		Pawn(Other).Died(Pawn(Other).Enemy, 'Fell', Location);
	else		
		Other.Destroy();
}

simulated function LinkToSkybox()
{
	local skyzoneinfo Sky;

	Super.LinkToSkybox();

	foreach AllActors( class 'SkyZoneInfo', Sky, Event )
	{
		SkyZone = Sky;
	}
}

defaultproperties
{
}
