//-----------------------------------------------------------
//
//-----------------------------------------------------------
class PowerShockTentacle expands ASMDShockTentacle;

function PlayRangedAttack() {

	local vector HitLocation, HitNormal, StartTrace, EndTrace, X, Y, Z;
	local rotator AdjustedAim;
	local PlayerPawn PP;
	local bool bAltFire, bComboShot;
	local actor Other;

	MakeNoise(1.0);
	GetAxes(ViewRotation, X, Y, Z);
	StartTrace = Location + CollisionHeight * vect(0, 0, -1.2);
	EndTrace = StartTrace + 1.0 * (FRand() - 0.5) * Y * 1000
		+ 1.0 * (FRand() - 0.5) * Z * 1000;

	bComboShot = false;
	if (MyShockProj != None) {
		foreach VisibleCollidingActors(class'PlayerPawn', PP, 250, MyShockProj.Location) {
			if (PP != None)	{
				bComboShot = true;
			}
		}
	}

	bAltFire = (FRand() > 0.55);
	if (bComboShot) {
		Other = TraceShot(HitLocation, HitNormal, MyShockProj.Location, StartTrace);
		if (Other != None) {
			SpawnEffect(HitLocation, StartTrace);
			if (ShockProj(Other) != None)
				ShockProj(Other).SuperExplosion();
			else
				Spawn(class'ut_RingExplosion5', , , HitLocation + HitNormal * 8, rotator(HitNormal));
			if ((Other != None) && (Other != self))
				Other.TakeDamage(40, self, HitLocation, vect(60000, 60000, 60000), 'jolted');
		}
		MyShockProj = None;
	} else if (bAltFire && (LastAltShotTime + 2.0) < Level.TimeSeconds) {
		MyShockProj = ShockProj(spawn(AltProjectile , self, Name, StartTrace, AdjustAim(ProjectileSpeed, StartTrace, AimErr, bLeadTarget, bWarnTarget)));
		LastAltShotTime = Level.TimeSeconds;
	} else {
		AdjustedAim = AdjustAim(1000000, StartTrace, AimErr, bLeadTarget, bWarnTarget);
		EndTrace += (10000 * vector(AdjustedAim));
		Other = TraceShot(HitLocation, HitNormal, EndTrace, StartTrace);
		SpawnEffect(HitLocation, StartTrace);
		if (ShockProj(Other) != None)
			ShockProj(Other).SuperExplosion();
		else
			Spawn(class'red_comboring', , , HitLocation + HitNormal * 8, rotator(HitNormal));
		if ((Other != self) && (Other != None))
			Other.TakeDamage(25, self, HitLocation, 60000.0 * X, 'jolted');
	}

	PlayAnim('Shoot', Refire);
}

function SpawnEffect(vector HitLocation, vector SmokeLocation) {

	local superShockBeam Smoke,shock;
	local Vector DVector;
	local int NumPoints;
	local rotator SmokeRotation;

	DVector = HitLocation - SmokeLocation;
	NumPoints = VSize(DVector)/135.0;
	if (NumPoints < 1)
		return;
	SmokeRotation = rotator(DVector);
	SmokeRotation.roll = Rand(65535);

	Smoke = Spawn(class'superShockBeam',,,SmokeLocation,SmokeRotation);
	Smoke.MoveAmount = DVector/NumPoints;
	Smoke.NumPuffs = NumPoints - 1;
}

defaultproperties
{
     AltProjectile=Class'MH4ever.powershockproj'
     AimSkill=AIM_Godlike
}
