//-----------------------------------------------------------
//
//-----------------------------------------------------------
class WaterGel expands BioGlob;

#exec obj load file="..\textures\genfluid.utx"

simulated function SetWall(vector HitNormal, Actor Wall)
{
	local vector TraceNorm, TraceLoc, Extent;
	local actor HitActor;
	local rotator RandRot;

	SurfaceNormal = HitNormal;
	if ( Level.NetMode != NM_DedicatedServer )
	RandRot = rotator(HitNormal);
	RandRot.Roll += 32768;
	SetRotation(RandRot);
	if ( Mover(Wall) != None )
		SetBase(Wall);
}

function Timer()
{
	local waterRingExplosion f;

	f = spawn(class'waterRingExplosion',,,Location + SurfaceNormal*8);
	if ( (Mover(Base) != None) && Mover(Base).bDamageTriggered )
		Base.TakeDamage( Damage, instigator, Location, MomentumTransfer * Normal(Velocity), MyDamageType);

	HurtRadius(damage * Drawscale, 200, MyDamageType, MomentumTransfer * Drawscale, Location);
	Destroy();
}

auto state Flying
{
	function ProcessTouch (Actor Other, vector HitLocation)
	{
		if ( Other.IsA('waterSplash') )
			return;
		if ( Pawn(Other)!=Instigator || bOnGround)
			Global.Timer();
	}
	simulated function HitWall( vector HitNormal, actor Wall )
	{

		SetPhysics(PHYS_None);
		MakeNoise(1);
		bOnGround = True;
		PlaySound(ImpactSound);
		SetWall(HitNormal, Wall);
		if ( DrawScale > 1 )
			NumSplash = int(2 * DrawScale) - 1;
		SpawnPoint = Location + 5 * HitNormal;
		DrawScale= FMin(DrawScale, 3.0);
		if ( NumSplash > 0 )
		{
			SpawnSplash();
			if ( NumSplash > 0 )
				SpawnSplash();
		}
		GoToState('OnSurface');
	}
}

function SpawnSplash()
{
	local vector Start;

	NumSplash--;
	Start = SpawnPoint + 4 * VRand();
	Spawn(class'watersplash',,,Start,Rotator(Start - Location));
}

state OnSurface
{
	function Tick(float DeltaTime)
	{
		if ( NumSplash > 0 )
		{
			SpawnSplash();
			if ( NumSplash > 0 )
				SpawnSplash();
			else
				Disable('Tick');
		}
		else
			Disable('Tick');
	}

	function ProcessTouch (Actor Other, vector HitLocation)
	{
		if ( Other.IsA('watersplash') )
			return;
		GotoState('Exploding');
	}
}

defaultproperties
{
     Damage=50.000000
     MyDamageType=Drowned
     Texture=Texture'genfluid.Water.Water1'
     DrawScale=4.000000
     LightHue=150
}
